

import java.util.ArrayList;
import java.util.List;

import javax.jdo.annotations.Index;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.TableGenerator;

@Entity
@TableGenerator(name="IdTableGen", initialValue=1, allocationSize=50)
public class Organisation {

    private String organisationId = null;
	private List<ElectronicAddress> electronicAddresses = new ArrayList<ElectronicAddress>();
	private long id;

	/**
	 * @return the object id
	 */
	@Id
	@GeneratedValue(strategy=GenerationType.TABLE, generator="IdTableGen")
	public long getId() {
		return id;
	}

	/**
	 * @param id the id to be set
	 */
	public void setId(long id) {
		this.id = id;
	}
  
    public Organisation() {
    	super();
    }
    
    public void addElectronicAddress(ElectronicAddress electronicAddress) {
        electronicAddresses.add(electronicAddress);
    }
    /**
     * @return the orgId
     */
    @Index(unique="true")
    public String getOrganisationId() {
        return organisationId;
    }

    public void setOrganisationId(String orgId) {
        this.organisationId = orgId;
    }

    @OneToMany(cascade=CascadeType.ALL, fetch=FetchType.EAGER, orphanRemoval=true)
	public List<ElectronicAddress> getElectronicAddresses() {
		return electronicAddresses;
	}

	public void setElectronicAddresses(List<ElectronicAddress> electronicAddresses) {
		this.electronicAddresses = electronicAddresses;
	}
}
