

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

public class OrphanRemovalTest  {
	public static void main(String [] args){
		EntityManagerFactory emf = Persistence.createEntityManagerFactory(
                "objectdb:test.tmp;drop");
		long orgId=0;
		
        Organisation newOrganisation = new Organisation();
        newOrganisation.setOrganisationId("newOrganisation");       
        newOrganisation.addElectronicAddress(new ElectronicAddress("natalia.levine@contextspace.com"));

        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();                
        em.persist(newOrganisation);
        em.getTransaction().commit(); 
        orgId=newOrganisation.getId();
        
        em.close();        
        em = emf.createEntityManager();
        
        Organisation originalOrganisation = em.find(Organisation.class, orgId);       
        originalOrganisation.getElectronicAddresses().clear();        
        originalOrganisation.addElectronicAddress(new ElectronicAddress("natalia@contextspace.com"));
        
        em.getTransaction().begin();
        em.merge(originalOrganisation);
        em.getTransaction().commit();
        
        TypedQuery<ElectronicAddress> q3 = em.createQuery("select t from " + ElectronicAddress.class.getName() + " t", ElectronicAddress.class);
		List<ElectronicAddress> res3 = q3.getResultList();
		
		System.out.println("Number of addresses: "+res3.size());
        em.close();
	}
}
